local ScenarioFramework = import('/lua/ScenarioFramework.lua');
local Entity = import('/lua/sim/Entity.lua').Entity
--local EffectTemplate = import('/lua/EffectTemplates.lua')

--TECH1,LAND,TANK
local LandUnits = { "ual0101" , "ual0106" , "ual0201" , "ual0104" , "ual0103" , "url0107" , "url0101" , "url0106" , "url0104" , "url0103" , "uel0101" , "uel0106" , "uel0201" , "uel0104" , "uel0103" , "xsl0101" , "xsl0201" , "xsl0104" , "xsl0103" ,
					"xal0203" , "ual0202" , "ual0205" , "ual0111" , "ual0307" , "url0203" , "url0202" , "url0205" , "xrl0302" , "url0111" , "url0306" , "drl0204" , "uel0203" , "del0204" , "uel0202" , "uel0205" , "uel0111" , "uel0307" , "xsl0202" , "xsl0203" , "xsl0205" , "xsl0111" , 
					"ual0303" , "ual0304" , "dal0310" , "xal0305" , "xrl0305" , "url0304" , "url0303" , "uel0303" , "uel0304" , "xel0306" , "xsl0304" , "xsl0307" , "xsl0303" , "xsl0305" ,
					"ual0401" , "xrl0403" , "url0401" , "url0402" , "xel0305" , "uel0401" , "xsl0401" }

local NavyUnits = { "uas0102" , "uas0203" , "uas0103" , "urs0203" , "urs0103" , "ues0203" , "ues0103" , "xss0203" , "xss0103" , "xss0202" , 
					"uas0202" , "uas0201" , "xas0204" , "xrs0205" , "urs0202" , "urs0201" , "xrs0204" , "ues0202" , "ues0201" , "xes0205" , "xes0102" , "xss0201" ,
					"uas0303" , "uas0302" , "xas0306" , "urs0303" , "urs0302" , "xes0307" , "ues0302" , "xss0303" , "xss0304" ,
					"uas0401" , "ues0401" }

local AirUnits = { "uaa0101" , "uaa0103" , "uaa0102" , "uaa0107" , "ura0101" , "ura0103" , "ura0102" , "ura0107" , "xra0105" , "uea0101" , "uea0103" , "uea0102" , "uea0107" , "xsa0101" , "xsa0103" , "xsa0102" , "xsa0107" ,
				   "uaa0104" , "xaa0202" , "daa0206" , "uaa0203" , "uaa0204" , "ura0104" , "dra0202" , "ura0204" , "uea0104" , "dea0202" , "uea0203" , "uea0204" , "xsa0104" , "xsa0202" , "xsa0204" , "xsa0203" ,
				   "xaa0305" , "uaa0303" , "uaa0302" , "uaa0304" , "xaa0306" , "ura0303" , "xra0305" , "ura0302" , "ura0304" , "uea0303" , "xea0306" , "uea0305" , "uea0302" , "uea0304" , "xsa0303" , "xsa0302" , "xsa0304" , 
				   "ura0401"}
					

randomunit = function(self)
	while true do
		WaitSeconds(1)
		local unitKills = self:GetStat('KILLS', 0).Value
		if not self:IsBeingBuilt() and unitKills > 4 then
			local replacement = false
			if EntityCategoryContains(categories.AIR, self) then
				replacement = ScenarioFramework.GetRandomEntry(AirUnits)
			elseif EntityCategoryContains(categories.NAVAL, self) then
				replacement = ScenarioFramework.GetRandomEntry(NavyUnits)
			elseif EntityCategoryContains(categories.LAND + categories.MOBILE - categories.STRUCTURE, self) then
				replacement = ScenarioFramework.GetRandomEntry(LandUnits)
			end
			
			if not replacement == false then
				local unitarmy = scnArmy(self)
				local unitorient = self:GetOrientation()
				local unitpos = self:GetPosition()				
				newunit = CreateUnitHPR(replacement, unitarmy, unitpos.x , unitpos.y , unitpos.z , unitorient.x,unitorient.y,unitorient.z)
			
				local unitdamage = self:GetHealth() / self:GetMaxHealth()
				
				newunit:SetMaxHealth(self:GetMaxHealth() * 1.1)
				newunit:SetHealth(newunit ,newunit:GetMaxHealth() * unitdamage)
				
				spawnOutEffect(self)
			end
		end
	end
end

spawnEffect = function(unit) 
   unit:PlayUnitSound('TeleportStart') 
   unit:PlayUnitAmbientSound('TeleportLoop') 
   WaitSeconds( 0.1 ) 
   unit:PlayTeleportInEffects() 
   WaitSeconds( 0.1 ) 
   unit:StopUnitAmbientSound('TeleportLoop') 
   unit:PlayUnitSound('TeleportEnd') 
end 

spawnOutEffect = function(unit) 
   unit:PlayUnitSound('TeleportStart') 
   unit:PlayUnitAmbientSound('TeleportLoop') 
   WaitSeconds( 0.1 ) 
   unit:PlayTeleportInEffects() 
   WaitSeconds( 0.1 ) 
   unit:StopUnitAmbientSound('TeleportLoop') 
   unit:PlayUnitSound('TeleportEnd') 
   unit:Destroy()
end 

scnArmy = function(unit) 
   local armyIndex = unit:GetArmy() 
   return indexToArmy(armyIndex) 
end 

--given an army index returns an army 
indexToArmy = function(armyIndex) 
   local army = ListArmies()[armyIndex] 
   return army 
end 
